# Copyright (c) 2000-2014, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with coreonly
%bcond_with gcj_support
%bcond_without jsf_ri
%bcond_without repolib

%if %with coreonly
%bcond_with apps
%bcond_with manual
%bcond_with zips
%else
%bcond_without apps
%bcond_without manual
%bcond_without zips
%endif

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section free

Name:           struts
Version:        1.3.10
Release:        6%{?dist}
Epoch:          0
Summary:        Web application framework
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://struts.apache.org/
Source0:        http://archive.apache.org/dist/struts/source/struts-1.3.10-src.zip
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        http://svn.apache.org/repos/asf/struts/maven/tags/STRUTS_MASTER_4/pom.xml
Source4:        %{name}-checks.xml
Patch0:         struts-1.3.8-core-pom.patch
Patch1:         struts-1.3.10-Tomcat5xTestSetup.patch
Patch2:         struts-1.3.8-assembly-pom.patch
Patch3:         struts-1.3.10-pom.patch
Patch4:         struts-1.3.8-no-sign.patch
Patch5:         struts-1.3.8-no-versions.patch
Patch6:         struts-1.3.10-jsf-ri.patch
Patch7:         struts-1.3.8-no-apps.patch
Patch8:         struts-1.3.8-web-xml-version.patch
Patch9:         struts-1.3.8-apps-scripting-mailreader.patch
Patch10:        struts-1.3.10-struts-checks-xml.patch
Patch11:        struts-1.3.10-javadoc-link.patch
Patch12:        struts-1.3.10-site.patch
Patch13:        struts-1.3.10-CVE-2014-0114.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
Requires:       %{name}-extras = %{epoch}:%{version}-%{release}
BuildRequires:  jpackage-utils
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  junit
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-gpg
BuildRequires:  maven2-plugin-pmd
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-surefire-report
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jxr
BuildRequires:  maven-surefire-report-maven-plugin
BuildRequires:  cargo-maven2-plugin
BuildRequires:  commons-parent
BuildRequires:  dtddoc-maven2-plugin
BuildRequires:  taglib-maven2-plugin
BuildRequires:  bcel
BuildRequires:  javamail_1_4_api
BuildRequires:  jhighlight
BuildRequires:  maven2-default-skin
BuildRequires:  jakarta-taglibs-standard
BuildRequires:  servlet_2_4_api
BuildRequires:  jsp_2_0_api
%if %without jsf_ri
BuildRequires:  myfaces >= 0:1.0.9
%else
BuildRequires:  el_1_0_api
BuildRequires:  glassfish-jsf
BuildRequires:  jsp_2_1_api
%endif
BuildRequires:  antlr
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-beanutils-javadoc
BuildRequires:  jakarta-commons-digester
BuildRequires:  jakarta-commons-fileupload
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-logging-javadoc
BuildRequires:  jakarta-commons-validator
BuildRequires:  jakarta-commons-validator-javadoc
BuildRequires:  jakarta-oro
BuildRequires:  java-javadoc
# FIXME: this package was removed for EAP, but what about other packages?
#BuildRequires:  jboss-javaee-javadoc
BuildRequires:  xpp3-minimal
# For compilation
BuildRequires:  servletapi4
# For tests
BuildRequires:  tomcat5-servlet-2.4-api
BuildRequires:  tomcat6-el-1.0-api
BuildRequires:  tomcat5-jsp-2.0-api
BuildRequires:  tomcat6-jsp-2.1-api
%if %without coreonly
BuildRequires:  bsf
BuildRequires:  avalon-framework
BuildRequires:  avalon-logkit
BuildRequires:  groovy15
BuildRequires:  jakarta-commons-chain
BuildRequires:  jakarta-commons-codec
BuildRequires:  jakarta-commons-el
BuildRequires:  jakarta-taglibs-standard
BuildRequires:  log4j
# src/integration/apps-it/pom.xml:
BuildRequires:  htmlunit >= 0:1.8
BuildRequires:  cargo >= 0:0.8
%endif
BuildRequires:  velocity-jboss
BuildRequires:  zip
Obsoletes:      struts-webapps-tomcat3 < %{epoch}:%{version}
Provides:       struts-webapps-tomcat3 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-webapps-tomcat4 < %{epoch}:%{version}
Provides:       struts-webapps-tomcat4 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-webapps-tomcat5 < %{epoch}:%{version}
Provides:       struts-webapps-tomcat5 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-chain-webapps-tomcat3 < %{epoch}:%{version}
Provides:       struts-chain-webapps-tomcat3 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-chain-webapps-tomcat4 < %{epoch}:%{version}
Provides:       struts-chain-webapps-tomcat4 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-chain-webapps-tomcat5 < %{epoch}:%{version}
Provides:       struts-chain-webapps-tomcat5 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-el-webapps-tomcat3 < %{epoch}:%{version}
Provides:       struts-el-webapps-tomcat3 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-el-webapps-tomcat4 < %{epoch}:%{version}
Provides:       struts-el-webapps-tomcat4 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-el-webapps-tomcat5 < %{epoch}:%{version}
Provides:       struts-el-webapps-tomcat5 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-faces-webapps-tomcat3 < %{epoch}:%{version}
Provides:       struts-faces-webapps-tomcat3 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-faces-webapps-tomcat4 < %{epoch}:%{version}
Provides:       struts-faces-webapps-tomcat4 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-faces-webapps-tomcat5 < %{epoch}:%{version}
Provides:       struts-faces-webapps-tomcat5 = %{epoch}:%{version}-%{release}
Obsoletes:      struts-chain < %{epoch}:%{version}
Provides:       struts-chain = %{epoch}:%{version}-%{release}
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Welcome to the Struts Framework! The goal of this project is to provide
an open source framework useful in building web applications with Java
Servlet and JavaServer Pages (JSP) technology. Struts encourages
application architectures based on the Model-View-Controller (MVC)
design paradigm, colloquially known as Model 2 in discussions on various
servlet and JSP related mailing lists.

Struts includes the following primary areas of functionality:
A controller servlet that dispatches requests to appropriate Action
classes provided by the application developer.
JSP custom tag libraries, and associated support in the controller
servlet, that assists developers in creating interactive form-based
applications.

Utility classes to support XML parsing, automatic population of
JavaBeans properties based on the Java reflection APIs, and
internationalization of prompts and messages.
Struts is part of the Jakarta Project, sponsored by the Apache Software
Foundation. The official Struts home page is at
http://jakarta.apache.org/struts.

%if %with manual
%package manual
Summary:        Manual for %{name}
Group:          Development/Documentation
Requires:       %{name}-javadoc = %{epoch}:%{version}-%{release}

%description manual
Documentation for %{name}.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%package core
Summary:        Core for %{name}
Group:          Development/Java
Requires:       antlr >= 0:2.7.2
Requires:       jakarta-commons-beanutils >= 0:1.8.0
Requires:       jakarta-commons-chain >= 0:1.2
Requires:       jakarta-commons-digester >= 0:1.8
Requires:       jakarta-commons-logging >= 0:1.0.4
Requires:       jakarta-commons-validator >= 0:1.3.1
Requires:       jakarta-oro >= 0:2.0.8
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       commons-parent >= 0:7

%description core
%{summary}.

%if %without coreonly
%package el
Summary:        EL extension for %{name}
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
Requires:       %{name}-taglib = %{epoch}:%{version}-%{release}
Requires:       %{name}-tiles = %{epoch}:%{version}-%{release}
Requires:       jakarta-taglibs-standard >= 0:1.0.6
#Provided:      servlet_2_3_api

%description el
%{summary}.

%package extras
Summary:        Extras for %{name}
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
#Provided:      servlet_2_3_api

%description extras
%{summary}.

%package faces
Summary:        Integration library for %{name}-faces
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
Requires:       %{name}-taglib = %{epoch}:%{version}-%{release}
Requires:       %{name}-tiles = %{epoch}:%{version}-%{release}
%if %without jsf_ri
#Provided:      myfaces >= 0:1.0.9
%else
#Provided:      glassfish-jsf
%endif
#Provided:      jsp_2_0_api
#Provided:      servlet_2_3_api

%description faces
%{summary}.

%package mailreader-dao
Summary:        %{name} mailreader-dao library
Group:          Development/Java
Requires:       jakarta-commons-digester >= 0:1.8
Requires:       jakarta-commons-logging >= 0:1.0.4

%description mailreader-dao
%{summary}.

%package scripting
Summary:        %{name} scripting library
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
Requires:       bsf >= 0:2.3
#Provided:      servlet_2_3_api

%description scripting
%{summary}.

%package taglib
Summary:        %{name} taglib library
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
#Provided:      servlet_2_3_api

%description taglib
%{summary}.

%package tiles
Summary:        %{name} tiles library
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
#Provided:      servlet_2_3_api

%description tiles
%{summary}.
%endif # coreonly

%if %with apps
%package webapp-blank
Summary:        Sample %{name} blank webapp
Group:          Development/Java
Requires:       %{name}-taglib = %{epoch}:%{version}-%{release}
Requires:       %{name}-tiles = %{epoch}:%{version}-%{release}
#Provided:      servlet_2_3_api

%description webapp-blank
%{summary}.

%package webapp-cookbook
Summary:        Sample %{name} cookbook webapp
Group:          Development/Java
Requires:       %{name}-core = %{epoch}:%{version}-%{release}
Requires:       %{name}-taglib = %{epoch}:%{version}-%{release}
#Provided:      servlet_2_3_api

%description webapp-cookbook
%{summary}.

%package webapp-el-example
Summary:        Sample %{name} EL webapp
Group:          Development/Java
Requires:       antlr
Requires:       avalon-framework
Requires:       avalon-logkit
Requires:       jakarta-commons-beanutils
Requires:       jakarta-commons-chain
Requires:       jakarta-commons-digester
Requires:       jakarta-commons-logging
Requires:       jakarta-commons-validator
Requires:       jakarta-taglibs-standard
Requires:       log4j
Requires:       jakarta-oro
Requires:       %{name}-el = %{epoch}:%{version}-%{release}
#Provided:      servlet_2_3_api

%description webapp-el-example
%{summary}.

%package webapp-examples
Summary:        Sample %{name} webapp
Group:          Development/Java
Requires:       %{name}-extras = %{epoch}:%{version}-%{release}
Requires:       %{name}-taglib = %{epoch}:%{version}-%{release}
#Provided:      servlet_2_3_api
Requires:       jakarta-taglibs-standard >= 0:1.0.6
Requires:       jakarta-commons-fileupload >= 0:1.1.1

%description webapp-examples
%{summary}.

%package webapps-faces
Summary:        Sample %{name} faces webapps
Group:          Development/Java
%if %with jsf_ri
#Optional:      myfaces >= 0:1.0.9
%else
#Optional:      glassfish-jsf
%endif
Requires:       jakarta-commons-codec >= 0:1.2
Requires:       jakarta-commons-el >= 0:1.0
Requires:       jakarta-taglibs-standard >= 0:1.0.6
Requires:       %{name}-faces = %{epoch}:%{version}-%{release}
Requires:       %{name}-tiles = %{epoch}:%{version}-%{release}
#Provided:      servlet_2_3_api

%description webapps-faces
%{summary}.

%package webapp-mailreader
Summary:        Sample %{name} mailreader webapp
Group:          Development/Java
Requires:       %{name}-extras = %{epoch}:%{version}-%{release}
Requires:       %{name}-mailreader-dao = %{epoch}:%{version}-%{release}
Requires:       %{name}-taglib = %{epoch}:%{version}-%{release}
#Provided:      servlet_2_3_api

%description webapp-mailreader
%{summary}.

%package webapp-scripting-mailreader
Summary:        Sample %{name} scripting mailreader webapp
Group:          Development/Java
Requires:       groovy15
Requires:       %{name}-extras = %{epoch}:%{version}-%{release}
Requires:       %{name}-mailreader-dao = %{epoch}:%{version}-%{release}
Requires:       %{name}-scripting = %{epoch}:%{version}-%{release}
Requires:       %{name}-taglib = %{epoch}:%{version}-%{release}
#Provided:      servlet_2_3_api

%description webapp-scripting-mailreader
%{summary}.
%endif # apps

%if %with zips
%package zip
Summary:     Container for the zipped distribution of %{name}
Group:       Development

%description zip
Container for the zipped distribution of %{name}.

%package src-zip
Summary:     Container for the sources of %{name}
Group:       Development

%description src-zip
Container for the sources of %{name}.
%endif # zips

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%patch3 -p0 -b .sav4
%patch4 -p0 -b .sav4
%patch5 -p0 -b .sav5
%if %with jsf_ri
%patch6 -p0 -b .sav6
%endif
%if %without apps
%patch7 -p0 -b .sav7
%endif
%patch8 -p0 -b .sav8
%patch9 -p0 -b .sav9
%patch10 -p0 -b .sav10
%patch11 -p0 -b .sav11
%patch12 -p0 -b .sav12
%patch13 -p0 -b .sav13

%if %without jsf_ri
perl -pi -e 's/^MYFACES_BEGIN.*\n$//g;' \
         -e 's/^MYFACES_END.*\n$//g;' \
%else
perl -pi -e 's/^MYFACES_BEGIN.*\n$/<!--\r\n/g;' \
         -e 's/^MYFACES_END.*\n$/-->\r\n/g;' \
%endif
    src/apps/faces-example1/src/main/webapp/WEB-INF/web.xml \
    src/apps/faces-example2/src/main/webapp/WEB-INF/web.xml

cp -p %{SOURCE1} maven2-settings.xml

cp -p %{SOURCE3} pom.xml

cp -p %{SOURCE4} src/struts_checks.xml
cp -p %{SOURCE4} src/apps/struts_checks.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://${PWD}/.m2/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://${PWD}/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://${PWD}/.m2/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file://%{_datadir}/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file://%{_datadir}/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%if %with zips
# Create src-zip
mkdir -p dist/%{name}-%{version}
cd dist/%{name}-%{version}
cp -pr ../../src .
cp -pr ../../*.txt .
zip -q -9 -r ../%{name}-%{version}-src.zip * -x \*.sav* -x maven2-settings.xml
rm -r src
cd ../../
%endif

%build
DIR=${PWD}
export M2SETTINGS=${PWD}/maven2-settings.xml
export MAVEN_REPO_LOCAL=${PWD}/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms
# FIXME: separate RPM needed
cp -p %{SOURCE3} $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/org.apache.struts-struts-master.pom
export MAVEN_OPTS="-Djava.awt.headless=true -Xmx2048m -XX:-UseGCOverheadLimit"
%{_bindir}/mvn-jpp -B -e -s ${M2SETTINGS} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven2.jpp.depmap.file=%{SOURCE2} -Dcargo.tomcat5x.home=%{_datadir}/tomcat5 -Dmaven.test.failure.ignore -Dmaven.test.skip -DaltDeploymentRepository=remote-repository::default::file://${DIR}/maven2-brew -Dcheckstyle.skip deploy
pushd src/core
%{_bindir}/mvn-jpp -B -e -s ${M2SETTINGS} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven2.jpp.depmap.file=%{SOURCE2} -Dcargo.tomcat5x.home=%{_datadir}/tomcat5 -Dmaven.test.failure.ignore -Dmaven.test.skip -DaltDeploymentRepository=remote-repository::default::file://${DIR}/maven2-brew -Dcheckstyle.skip deploy
popd

%if %without coreonly
pushd src
for i in taglib tiles faces el scripting .; do
pushd $i
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dcargo.tomcat5x.home=%{_datadir}/tomcat5 \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.test.skip=true \
        -DaltDeploymentRepository=remote-repository::default::file://${DIR}/maven2-brew \
        -Dcheckstyle.skip \
        deploy -P apps,itest,pre-assembly
popd
done
popd

pushd src
%{_bindir}/mvn-jpp -B -e -s ${M2SETTINGS} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven2.jpp.depmap.file=%{SOURCE2} -Dcargo.tomcat5x.home=%{_datadir}/tomcat5 -Dmaven.test.failure.ignore -Dmaven.test.skip -DaltDeploymentRepository=remote-repository::default::file://${DIR}/maven2-brew -Dcheckstyle.skip javadoc:aggregate -P apps,itest,pre-assembly
%{_bindir}/mvn-jpp -B -e -s ${M2SETTINGS} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven2.jpp.depmap.file=%{SOURCE2} -Dcargo.tomcat5x.home=%{_datadir}/tomcat5 -Dmaven.test.failure.ignore -Dmaven.test.skip -DaltDeploymentRepository=remote-repository::default::file://${DIR}/maven2-brew -Dcheckstyle.skip site -P apps,itest,pre-assembly
popd

pushd src/assembly
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
    assembly:assembly
popd
%endif

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
install -p -m 0644 src/core/target/%{name}-core-%{version}.jar %{buildroot}%{_javadir}/%{name}-core-%{version}.jar
ln -s %{name}-core-%{version}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%if %without coreonly
install -p -m 0644 src/el/target/%{name}-el-%{version}.jar %{buildroot}%{_javadir}/%{name}-el-%{version}.jar
install -p -m 0644 src/extras/target/%{name}-extras-%{version}.jar %{buildroot}%{_javadir}/%{name}-extras-%{version}.jar
install -p -m 0644 src/faces/target/%{name}-faces-%{version}.jar %{buildroot}%{_javadir}/%{name}-faces-%{version}.jar
install -p -m 0644 src/mailreader-dao/target/%{name}-mailreader-dao-%{version}.jar %{buildroot}%{_javadir}/%{name}-mailreader-dao-%{version}.jar
install -p -m 0644 src/scripting/target/%{name}-scripting-%{version}.jar %{buildroot}%{_javadir}/%{name}-scripting-%{version}.jar
install -p -m 0644 src/taglib/target/%{name}-taglib-%{version}.jar %{buildroot}%{_javadir}/%{name}-taglib-%{version}.jar
install -p -m 0644 src/tiles/target/%{name}-tiles-%{version}.jar %{buildroot}%{_javadir}/%{name}-tiles-%{version}.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} ${jar/-%{version}/}; done)
%if %with apps
pushd %{buildroot}%{_javadir}
ln -s %{_datadir}/%{name}/apps %{name}-apps
popd
%endif

# poms and depmap frags
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
%if %with apps
install -p -m 0644 src/apps/blank/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-apps-blank.pom
%add_to_maven_depmap org.apache.struts struts-blank %{version} JPP/%{name}-apps blank
install -p -m 0644 src/apps/cookbook/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-apps-cookbook.pom
%add_to_maven_depmap org.apache.struts struts-cookbook %{version} JPP/%{name}-apps cookbook
install -p -m 0644 src/apps/el-example/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-apps-el-example.pom
%add_to_maven_depmap org.apache.struts struts-el %{version} JPP/%{name}-apps el-example
install -p -m 0644 src/apps/examples/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-apps-examples.pom
%add_to_maven_depmap org.apache.struts struts-examples %{version} JPP/%{name}-apps examples
install -p -m 0644 src/apps/faces-example1/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-apps-faces-example1.pom
%add_to_maven_depmap org.apache.struts struts-faces-example1 %{version} JPP/%{name}-apps faces-example1
install -p -m 0644 src/apps/faces-example2/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-apps-faces-example2.pom
%add_to_maven_depmap org.apache.struts struts-faces-example2 %{version} JPP/%{name}-apps faces-example2
install -p -m 0644 src/apps/mailreader/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-apps-mailreader.pom
%add_to_maven_depmap org.apache.struts struts-mailreader %{version} JPP/%{name}-apps mailreader
install -p -m 0644 src/apps/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-apps.pom
%add_to_maven_depmap org.apache.struts struts-apps %{version} JPP %{name}-apps
install -p -m 0644 src/apps/scripting-mailreader/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-apps-scripting-mailreader.pom
%add_to_maven_depmap org.apache.struts struts-scripting-mailreader %{version} JPP/%{name}-apps scripting-mailreader
%endif
install -p -m 0644 src/assembly/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-assembly.pom
%add_to_maven_depmap org.apache.struts struts-assembly %{version} JPP %{name}-assembly
install -p -m 0644 src/core/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.apache.struts struts-core %{version} JPP %{name}
install -p -m 0644 src/integration/apps-it/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-it-apps.pom
%add_to_maven_depmap org.apache.struts struts-it-apps %{version} JPP %{name}-it-apps
install -p -m 0644 src/integration/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-it.pom
%add_to_maven_depmap org.apache.struts struts-it %{version} JPP %{name}-it
install -p -m 0644 src/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%add_to_maven_depmap org.apache.struts struts-parent %{version} JPP %{name}-parent
%if %without coreonly
install -p -m 0644 src/el/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-el.pom
%add_to_maven_depmap org.apache.struts struts-el %{version} JPP %{name}-el
install -p -m 0644 src/extras/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-extras.pom
%add_to_maven_depmap org.apache.struts struts-extras %{version} JPP %{name}-extras
install -p -m 0644 src/faces/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-faces.pom
%add_to_maven_depmap org.apache.struts struts-faces %{version} JPP %{name}-faces
install -p -m 0644 src/mailreader-dao/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-mailreader-dao.pom
%add_to_maven_depmap org.apache.struts struts-mailreader-dao %{version} JPP %{name}-mailreader-dao
install -p -m 0644 src/scripting/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-scripting.pom
%add_to_maven_depmap org.apache.struts struts-scripting %{version} JPP %{name}-scripting
install -p -m 0644 src/taglib/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-taglib.pom
%add_to_maven_depmap org.apache.struts struts-taglib %{version} JPP %{name}-taglib
install -p -m 0644 src/tiles/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-tiles.pom
%add_to_maven_depmap org.apache.struts struts-tiles %{version} JPP %{name}-tiles
%endif
install -p -m 0644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-master.pom
%add_to_maven_depmap org.apache.struts struts-master %{version} JPP %{name}-master

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr src/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# data
install -d -m 755 %{buildroot}%{_datadir}/%{name}
install -p -m 0644 src/el/src/main/resources/META-INF/tld/*.tld %{buildroot}%{_datadir}/%{name}
install -p -m 0644 src/faces/src/main/resources/META-INF/tld/*.tld %{buildroot}%{_datadir}/%{name}
install -p -m 0644 src/taglib/src/main/resources/META-INF/tld/*.tld %{buildroot}%{_datadir}/%{name}
install -p -m 0644 src/tiles/src/main/resources/META-INF/tld/*.tld %{buildroot}%{_datadir}/%{name}
install -p -m 0644 src/target/site/dtds/*.dtd %{buildroot}%{_datadir}/%{name}
install -p -m 0644 src/core/src/main/resources/org/apache/struts/validator/vali*.xml %{buildroot}%{_datadir}/%{name}

%if %with apps
install -d -m 755 %{buildroot}%{_datadir}/%{name}/apps
pushd %{buildroot}%{_datadir}/%{name}/apps
mkdir blank.war
pushd blank.war
unzip -qq $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-blank*.war
rm -v WEB-INF/lib/*
pushd WEB-INF/lib
#WEB-INF/lib/antlr-2.7.2.jar
ln -s $(build-classpath antlr) .
#WEB-INF/lib/avalon-framework-4.1.3.jar
ln -s $(build-classpath avalon-framework) .
#WEB-INF/lib/commons-beanutils-1.8.0.jar
ln -s $(build-classpath commons-beanutils) .
#WEB-INF/lib/commons-chain-1.2.jar
ln -s $(build-classpath commons-chain) .
#WEB-INF/lib/commons-collections-3.1.jar
ln -s $(build-classpath commons-collections) .
#WEB-INF/lib/commons-digester-1.8.jar
ln -s $(build-classpath commons-digester) .
#WEB-INF/lib/commons-logging-1.0.4.jar
ln -s $(build-classpath commons-logging) .
#WEB-INF/lib/commons-validator-1.3.1.jar
ln -s $(build-classpath commons-validator) .
#WEB-INF/lib/log4j-1.2.12.jar
ln -s $(build-classpath log4j) .
#WEB-INF/lib/logkit-1.0.1.jar
ln -s $(build-classpath avalon-logkit) .
#WEB-INF/lib/mail-1.4.jar
ln -s $(build-classpath javamail_1_4_api) .
#WEB-INF/lib/oro-2.0.8.jar
ln -s $(build-classpath jakarta-oro) .
#WEB-INF/lib/struts-core-1.3.10.jar
ln -s %{_javadir}/struts-core.jar .
#WEB-INF/lib/struts-taglib-1.3.10.jar
ln -s %{_javadir}/struts-taglib.jar .
#WEB-INF/lib/struts-tiles-1.3.10.jar
ln -s %{_javadir}/struts-tiles.jar .
popd
rm $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-blank*.war
zip -q -r $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-blank.war .
popd
mkdir cookbook.war
pushd cookbook.war
unzip -qq $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-cookbook*.war
rm -v WEB-INF/lib/*
pushd WEB-INF/lib
#WEB-INF/lib/antlr-2.7.2.jar
ln -s $(build-classpath antlr) .
#WEB-INF/lib/avalon-framework-4.1.3.jar
ln -s $(build-classpath avalon-framework) .
#WEB-INF/lib/commons-beanutils-1.8.0.jar
ln -s $(build-classpath commons-beanutils) .
#WEB-INF/lib/commons-chain-1.2.jar
ln -s $(build-classpath commons-chain) .
#WEB-INF/lib/commons-collections-3.1.jar
ln -s $(build-classpath commons-collections) .
#WEB-INF/lib/commons-digester-1.8.jar
ln -s $(build-classpath commons-digester) .
#WEB-INF/lib/commons-logging-1.0.4.jar
ln -s $(build-classpath commons-logging) .
#WEB-INF/lib/commons-validator-1.3.1.jar
ln -s $(build-classpath commons-validator) .
#WEB-INF/lib/log4j-1.2.12.jar
ln -s $(build-classpath log4j) .
#WEB-INF/lib/logkit-1.0.1.jar
ln -s $(build-classpath avalon-logkit) .
#WEB-INF/lib/mail-1.4.jar
ln -s $(build-classpath javamail_1_4_api) .
#WEB-INF/lib/oro-2.0.8.jar
ln -s $(build-classpath jakarta-oro) 
#WEB-INF/lib/struts-core-1.3.10.jar
ln -s %{_javadir}/struts-core.jar .
#WEB-INF/lib/struts-taglib-1.3.10.jar
ln -s %{_javadir}/struts-taglib.jar .
popd
rm $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-cookbook*.war
zip -q -r $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-cookbook.war .
popd
mkdir el-example.war
pushd el-example.war
unzip -qq $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-el-example*.war
rm -v WEB-INF/lib/*
pushd WEB-INF/lib
#WEB-INF/lib/antlr-2.7.2.jar
ln -s $(build-classpath antlr) .
#WEB-INF/lib/avalon-framework-4.1.3.jar
ln -s $(build-classpath avalon-framework) .
#WEB-INF/lib/commons-beanutils-1.8.0.jar
ln -s $(build-classpath commons-beanutils) .
#WEB-INF/lib/commons-chain-1.2.jar
ln -s $(build-classpath commons-chain) .
#WEB-INF/lib/commons-collections-3.1.jar
ln -s $(build-classpath commons-collections) .
#WEB-INF/lib/commons-digester-1.8.jar
ln -s $(build-classpath commons-digester) .
#WEB-INF/lib/commons-logging-1.0.4.jar
ln -s $(build-classpath commons-logging) .
#WEB-INF/lib/commons-validator-1.3.1.jar
ln -s $(build-classpath commons-validator) .
#WEB-INF/lib/jstl-1.0.2.jar
ln -s $(build-classpath jakarta-taglibs-core) .
#WEB-INF/lib/log4j-1.2.12.jar
ln -s $(build-classpath log4j) .
#WEB-INF/lib/logkit-1.0.1.jar
ln -s $(build-classpath avalon-logkit) .
#WEB-INF/lib/mail-1.4.jar
ln -s $(build-classpath javamail_1_4_api) .
#WEB-INF/lib/oro-2.0.8.jar
ln -s $(build-classpath jakarta-oro) .
#WEB-INF/lib/standard-1.0.6.jar
ln -s $(build-classpath jakarta-taglibs-standard) .
#WEB-INF/lib/struts-core-1.3.10.jar
ln -s %{_javadir}/struts-core.jar .
#WEB-INF/lib/struts-el-1.3.10.jar
ln -s %{_javadir}/struts-el.jar .
#WEB-INF/lib/struts-taglib-1.3.10.jar
ln -s %{_javadir}/struts-taglib.jar .
popd
rm $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-el-example*.war
zip -q -r $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-el-example.war .
popd
mkdir examples.war
pushd examples.war
unzip -qq $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-examples*.war
rm -v WEB-INF/lib/*
pushd WEB-INF/lib
#WEB-INF/lib/antlr-2.7.2.jar
ln -s $(build-classpath antlr) .
#WEB-INF/lib/avalon-framework-4.1.3.jar
ln -s $(build-classpath avalon-framework) .
#WEB-INF/lib/commons-beanutils-1.8.0.jar
ln -s $(build-classpath commons-beanutils) .
#WEB-INF/lib/commons-chain-1.2.jar
ln -s $(build-classpath commons-chain) .
#WEB-INF/lib/commons-collections-3.1.jar
ln -s $(build-classpath commons-collections) .
#WEB-INF/lib/commons-digester-1.8.jar
ln -s $(build-classpath commons-digester) .
#WEB-INF/lib/commons-fileupload-1.1.1.jar
ln -s $(build-classpath commons-fileupload) .
#WEB-INF/lib/commons-logging-1.0.4.jar
ln -s $(build-classpath commons-logging) .
#WEB-INF/lib/commons-validator-1.3.1.jar
ln -s $(build-classpath commons-validator) .
#WEB-INF/lib/jstl-1.0.6.jar
ln -s $(build-classpath jakarta-taglibs-core) .
#WEB-INF/lib/log4j-1.2.12.jar
ln -s $(build-classpath log4j) .
#WEB-INF/lib/logkit-1.0.1.jar
ln -s $(build-classpath avalon-logkit) .
#WEB-INF/lib/mail-1.4.jar
ln -s $(build-classpath javamail_1_4_api) .
#WEB-INF/lib/oro-2.0.8.jar
ln -s $(build-classpath jakarta-oro) .
#WEB-INF/lib/standard-1.0.6.jar
ln -s $(build-classpath jakarta-taglibs-standard) .
#WEB-INF/lib/struts-core-1.3.10.jar
ln -s %{_javadir}/struts-core.jar .
#WEB-INF/lib/struts-extras-1.3.10.jar
ln -s %{_javadir}/struts-extras.jar .
#WEB-INF/lib/struts-taglib-1.3.10.jar
ln -s %{_javadir}/struts-taglib.jar .
popd
rm $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-examples*.war
zip -q -r $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-examples.war .
popd
mkdir faces-example1.war
pushd faces-example1.war
unzip -qq $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-faces-example1*.war
rm -v WEB-INF/lib/*
pushd WEB-INF/lib
#WEB-INF/lib/antlr-2.7.2.jar
ln -s $(build-classpath antlr) .
#WEB-INF/lib/avalon-framework-4.1.3.jar
ln -s $(build-classpath avalon-framework) .
#WEB-INF/lib/commons-beanutils-1.8.0.jar
ln -s $(build-classpath commons-beanutils) .
#WEB-INF/lib/commons-chain-1.2.jar
ln -s $(build-classpath commons-chain) .
#WEB-INF/lib/commons-codec-1.2.jar
ln -s $(build-classpath commons-codec) .
#WEB-INF/lib/commons-collections-3.1.jar
ln -s $(build-classpath commons-collections) .
#WEB-INF/lib/commons-digester-1.8.jar
ln -s $(build-classpath commons-digester) .
#WEB-INF/lib/commons-el-1.0.jar
ln -s $(build-classpath commons-el) .
#WEB-INF/lib/commons-logging-1.0.4.jar
ln -s $(build-classpath commons-logging) .
#WEB-INF/lib/commons-validator-1.3.1.jar
ln -s $(build-classpath commons-validator) .
#WEB-INF/lib/jstl-1.0.2.jar
ln -s $(build-classpath jakarta-taglibs-core) .
#WEB-INF/lib/log4j-1.2.12.jar
ln -s $(build-classpath log4j) .
#WEB-INF/lib/logkit-1.0.1.jar
ln -s $(build-classpath avalon-logkit) .
#WEB-INF/lib/mail-1.4.jar
ln -s $(build-classpath javamail_1_4_api) .
%if %without jsf_ri
#WEB-INF/lib/myfaces-extensions-1.0.9.jar
ln -s $(build-classpath myfaces/myfaces-all) .
#WEB-INF/lib/myfaces-impl-1.0.9.jar
ln -s $(build-classpath myfaces/myfaces-impl) .
#WEB-INF/lib/myfaces-jsf-api-1.0.9.jar
ln -s $(build-classpath myfaces/myfaces-jsf-api) .
%else

%endif
#WEB-INF/lib/oro-2.0.8.jar
ln -s $(build-classpath jakarta-oro) .
#WEB-INF/lib/standard-1.0.6.jar
ln -s $(build-classpath jakarta-taglibs-standard) .
#WEB-INF/lib/struts-core-1.3.10.jar
ln -s %{_javadir}/struts-core.jar .
#WEB-INF/lib/struts-faces-1.3.10.jar
ln -s %{_javadir}/struts-faces.jar .
#WEB-INF/lib/struts-taglib-1.3.10.jar
ln -s %{_javadir}/struts-taglib.jar .
#WEB-INF/lib/struts-tiles-1.3.10.jar
ln -s %{_javadir}/struts-tiles.jar .
popd
rm $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-faces-example1*.war
zip -q -r $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-faces-example1.war .
popd
mkdir faces-example2.war
pushd faces-example2.war
unzip -qq $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-faces-example2*.war
rm -v WEB-INF/lib/*
pushd WEB-INF/lib
#WEB-INF/lib/antlr-2.7.2.jar
ln -s $(build-classpath antlr) .
#WEB-INF/lib/avalon-framework-4.1.3.jar
ln -s $(build-classpath avalon-framework) .
#WEB-INF/lib/commons-beanutils-1.8.0.jar
ln -s $(build-classpath commons-beanutils) .
#WEB-INF/lib/commons-chain-1.2.jar
ln -s $(build-classpath commons-chain) .
#WEB-INF/lib/commons-codec-1.2.jar
ln -s $(build-classpath commons-codec) .
#WEB-INF/lib/commons-collections-3.1.jar
ln -s $(build-classpath commons-collections) .
#WEB-INF/lib/commons-digester-1.8.jar
ln -s $(build-classpath commons-digester) .
#WEB-INF/lib/commons-el-1.0.jar
ln -s $(build-classpath commons-el) .
#WEB-INF/lib/commons-logging-1.0.4.jar
ln -s $(build-classpath commons-logging) .
#WEB-INF/lib/commons-validator-1.3.1.jar
ln -s $(build-classpath commons-validator) .
#WEB-INF/lib/jstl-1.0.2.jar
ln -s $(build-classpath jakarta-taglibs-core) .
#WEB-INF/lib/log4j-1.2.12.jar
ln -s $(build-classpath log4j) .
#WEB-INF/lib/logkit-1.0.1.jar
ln -s $(build-classpath avalon-logkit) .
#WEB-INF/lib/mail-1.4.jar
ln -s $(build-classpath javamail_1_4_api) .
%if %without jsf_ri
#WEB-INF/lib/myfaces-extensions-1.0.9.jar
ln -s $(build-classpath myfaces/myfaces-all) .
#WEB-INF/lib/myfaces-impl-1.0.9.jar
ln -s $(build-classpath myfaces/myfaces-impl) .
#WEB-INF/lib/myfaces-jsf-api-1.0.9.jar
ln -s $(build-classpath myfaces/myfaces-jsf-api) .
%else

%endif
#WEB-INF/lib/oro-2.0.8.jar
ln -s $(build-classpath jakarta-oro) .
#WEB-INF/lib/standard-1.0.6.jar
ln -s $(build-classpath jakarta-taglibs-standard) .
#WEB-INF/lib/struts-core-1.3.10.jar
ln -s %{_javadir}/struts-core.jar .
#WEB-INF/lib/struts-faces-1.3.10.jar
ln -s %{_javadir}/struts-faces.jar .
#WEB-INF/lib/struts-taglib-1.3.10.jar
ln -s %{_javadir}/struts-taglib.jar .
#WEB-INF/lib/struts-tiles-1.3.10.jar
ln -s %{_javadir}/struts-tiles.jar .
popd
rm $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-faces-example2*.war
zip -q -r $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-faces-example2.war .
popd
mkdir mailreader.war
pushd mailreader.war
unzip -qq $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-mailreader*.war
rm -v WEB-INF/lib/*
pushd WEB-INF/lib
#WEB-INF/lib/antlr-2.7.2.jar
ln -s $(build-classpath antlr) .
#WEB-INF/lib/avalon-framework-4.1.3.jar
ln -s $(build-classpath avalon-framework) .
#WEB-INF/lib/commons-beanutils-1.8.0.jar
ln -s $(build-classpath commons-beanutils) .
#WEB-INF/lib/commons-chain-1.2.jar
ln -s $(build-classpath commons-chain) .
#WEB-INF/lib/commons-collections-3.1.jar
ln -s $(build-classpath commons-collections) .
#WEB-INF/lib/commons-digester-1.8.jar
ln -s $(build-classpath commons-digester) .
#WEB-INF/lib/commons-logging-1.0.4.jar
ln -s $(build-classpath commons-logging) .
#WEB-INF/lib/commons-validator-1.3.1.jar
ln -s $(build-classpath commons-validator) .
#WEB-INF/lib/log4j-1.2.12.jar
ln -s $(build-classpath log4j) .
#WEB-INF/lib/logkit-1.0.1.jar
ln -s $(build-classpath avalon-logkit) .
#WEB-INF/lib/mail-1.4.jar
ln -s $(build-classpath javamail_1_4_api) .
#WEB-INF/lib/oro-2.0.8.jar
ln -s $(build-classpath jakarta-oro) .
#WEB-INF/lib/struts-core-1.3.10.jar
ln -s %{_javadir}/struts-core.jar .
#WEB-INF/lib/struts-extras-1.3.10.jar
ln -s %{_javadir}/struts-extras.jar .
#WEB-INF/lib/struts-mailreader-dao-1.3.10.jar
ln -s %{_javadir}/struts-mailreader-dao.jar .
#WEB-INF/lib/struts-taglib-1.3.10.jar
ln -s %{_javadir}/struts-taglib.jar .
popd
rm $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-mailreader*.war
zip -q -r $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-mailreader.war .
popd
mkdir scripting-mailreader.war
pushd scripting-mailreader.war
unzip -qq $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-scripting-mailreader*.war
rm -v WEB-INF/lib/*
pushd WEB-INF/lib
#WEB-INF/lib/ant-1.7.0.jar
ln -s $(build-classpath ant) .
#WEB-INF/lib/ant-launcher-1.7.0.jar
ln -s $(build-classpath ant-launcher) .
#WEB-INF/lib/antlr-2.7.2.jar
ln -s $(build-classpath antlr) .
#WEB-INF/lib/avalon-framework-4.1.3.jar
ln -s $(build-classpath avalon-framework) .
#WEB-INF/lib/bsf-2.3.0.jar
ln -s $(build-classpath bsf) .
#WEB-INF/lib/commons-beanutils-1.8.0.jar
ln -s $(build-classpath commons-beanutils) .
#WEB-INF/lib/commons-chain-1.2.jar
ln -s $(build-classpath commons-chain) .
#WEB-INF/lib/commons-collections-3.1.jar
ln -s $(build-classpath commons-collections) .
#WEB-INF/lib/commons-digester-1.8.jar
ln -s $(build-classpath commons-digester) .
#WEB-INF/lib/commons-logging-1.0.4.jar
ln -s $(build-classpath commons-logging) .
#WEB-INF/lib/commons-validator-1.3.1.jar
ln -s $(build-classpath commons-validator) .
#WEB-INF/lib/groovy-all-1.0-jsr-04.jar
ln -s $(build-classpath groovy15) .
#WEB-INF/lib/jline-0.9.94.jar
ln -s $(build-classpath jline) .
#WEB-INF/lib/log4j-1.2.12.jar
ln -s $(build-classpath log4j) .
#WEB-INF/lib/logkit-1.0.1.jar
ln -s $(build-classpath avalon-logkit) .
#WEB-INF/lib/mail-1.4.jar
ln -s $(build-classpath javamail_1_4_api) .
#WEB-INF/lib/oro-2.0.8.jar
ln -s $(build-classpath jakarta-oro) .
#WEB-INF/lib/struts-core-1.3.10.jar
ln -s %{_javadir}/struts-core.jar .
#WEB-INF/lib/struts-extras-1.3.10.jar
ln -s %{_javadir}/struts-extras.jar .
#WEB-INF/lib/struts-mailreader-dao-1.3.10.jar
ln -s %{_javadir}/struts-mailreader-dao.jar .
#WEB-INF/lib/struts-scripting-1.3.10.jar
ln -s %{_javadir}/struts-scripting.jar .
#WEB-INF/lib/struts-taglib-1.3.10.jar
ln -s %{_javadir}/struts-taglib.jar .
popd
rm $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-scripting-mailreader*.war
zip -q -r $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/struts-scripting-mailreader.war .
popd
popd
rm -rf struts-%{version}/apps
mkdir -p struts-%{version}/apps
cp -p $RPM_BUILD_DIR/%{name}-%{version}/src/assembly/target/apps/*.war struts-%{version}/apps/
rm src/assembly/target/assembly/out/struts-%{version}-apps.zip
zip -q -r src/assembly/target/assembly/out/struts-%{version}-apps.zip struts-%{version}/apps/
%endif # apps

%if %with zips
install -dm 755 %{buildroot}/%{_javadir}/jbossas-fordev/
%{__install} -p -m 0644 src/assembly/target/assembly/out/struts-%{version}-all.zip %{buildroot}%{_javadir}/jbossas-fordev/%{name}-%{version}-all.zip
%{__install} -p -m 0644 src/assembly/target/assembly/out/struts-%{version}-lib.zip %{buildroot}%{_javadir}/jbossas-fordev/%{name}-%{version}-lib.zip
%if %with apps
%{__install} -p -m 0644 src/assembly/target/assembly/out/struts-%{version}-apps.zip %{buildroot}%{_javadir}/jbossas-fordev/%{name}-%{version}-apps.zip
%endif
%{__install} -p -m 0644 src/assembly/target/assembly/out/struts-%{version}-src.zip %{buildroot}%{_javadir}/jbossas-fordev/%{name}-%{version}-src.zip
%{__install} -p -m 0644 src/assembly/target/assembly/out/struts-%{version}-docs.zip %{buildroot}%{_javadir}/jbossas-fordev/%{name}-%{version}-docs.zip
%endif

%if %with manual
rm -rf docs-tmp/
mkdir docs-tmp/
unzip -qq src/assembly/target/assembly/out/struts-%{version}-docs.zip -d docs-tmp/
install -dm 755 %{buildroot}%{_docdir}/%{name}-%{version}
cp -pr docs-tmp/struts-%{version}/* %{buildroot}%{_docdir}/%{name}-%{version}
rm -r %{buildroot}%{_docdir}/%{name}-%{version}/docs/apidocs
pushd %{buildroot}%{_docdir}/%{name}-%{version}/docs/
ln -s %{_javadocdir}/%{name} apidocs
popd
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%if %{gcj_support}
%post core
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun core
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %without coreonly
%if %{gcj_support}
%post el
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun el
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post extras
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun extras
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post faces
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun faces
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post mailreader-dao
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun mailreader-dao
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post scripting
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun scripting
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post taglib
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun taglib
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post tiles
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun tiles
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif
%endif # coreonly

%files
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%doc %{_docdir}/%{name}-%{version}/NOTICE.txt
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/struts-config_1_0.dtd
%{_datadir}/%{name}/struts-config_1_1.dtd
%{_datadir}/%{name}/struts-config_1_2.dtd
%{_datadir}/%{name}/struts-config_1_3.dtd
%{_datadir}/%{name}/tiles-config_1_1.dtd
%{_datadir}/%{name}/tiles-config_1_3.dtd
%{_datadir}/%{name}/struts-bean-el.tld
%{_datadir}/%{name}/struts-bean.tld
%{_datadir}/%{name}/struts-faces.tld
%{_datadir}/%{name}/struts-html-el.tld
%{_datadir}/%{name}/struts-html.tld
%{_datadir}/%{name}/struts-logic-el.tld
%{_datadir}/%{name}/struts-logic.tld
%{_datadir}/%{name}/struts-nested.tld
%{_datadir}/%{name}/struts-tiles-el.tld
%{_datadir}/%{name}/struts-tiles.tld
%{_datadir}/%{name}/validator-rules-compressed.xml
%{_datadir}/%{name}/validator-rules.xml
%{_datadir}/%{name}/web-app_2_3.dtd
%if %with apps
%{_javadir}/%{name}-apps
%{_javadir}-signed/%{name}-apps
%dir %{_datadir}/%{name}/apps
%{_datadir}/maven2/poms/JPP-%{name}-apps.pom
%endif
%{_datadir}/maven2/poms/JPP-%{name}-assembly.pom
%{_datadir}/maven2/poms/JPP-%{name}-it-apps.pom
%{_datadir}/maven2/poms/JPP-%{name}-it.pom
%{_datadir}/maven2/poms/JPP-%{name}-master.pom
%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%if %with manual
%files manual
%defattr(0644,root,root,0755)
%dir %doc %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files core
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-core-%{version}.jar
%{_javadir}*/%{name}-core.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-core-%{version}.jar.*
%endif

%if %without coreonly
%files el
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-el-%{version}.jar
%{_javadir}*/%{name}-el.jar
%{_datadir}/maven2/poms/JPP-%{name}-el.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-el-%{version}.jar.*
%endif

%files extras
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-extras-%{version}.jar
%{_javadir}*/%{name}-extras.jar
%{_datadir}/maven2/poms/JPP-%{name}-extras.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-extras-%{version}.jar.*
%endif

%files faces
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-faces-%{version}.jar
%{_javadir}*/%{name}-faces.jar
%{_datadir}/maven2/poms/JPP-%{name}-faces.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-faces-%{version}.jar.*
%endif

%files mailreader-dao
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-mailreader-dao-%{version}.jar
%{_javadir}*/%{name}-mailreader-dao.jar
%{_datadir}/maven2/poms/JPP-%{name}-mailreader-dao.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-mailreader-dao-%{version}.jar.*
%endif

%files scripting
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-scripting-%{version}.jar
%{_javadir}*/%{name}-scripting.jar
%{_datadir}/maven2/poms/JPP-%{name}-scripting.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-scripting-%{version}.jar.*
%endif

%files taglib
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-taglib-%{version}.jar
%{_javadir}*/%{name}-taglib.jar
%{_datadir}/maven2/poms/JPP-%{name}-taglib.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-taglib-%{version}.jar.*
%endif

%files tiles
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-tiles-%{version}.jar
%{_javadir}*/%{name}-tiles.jar
%{_datadir}/maven2/poms/JPP-%{name}-tiles.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-tiles-%{version}.jar.*
%endif
%endif # coreonly

%if %with apps
%files webapp-blank
%defattr(0644,root,root,0755)
%{_datadir}/%{name}/apps/blank.war
%{_datadir}/maven2/poms/JPP.%{name}-apps-blank.pom

%files webapp-cookbook
%defattr(0644,root,root,0755)
%{_datadir}/%{name}/apps/cookbook.war
%{_datadir}/maven2/poms/JPP.%{name}-apps-cookbook.pom

%files webapp-el-example
%defattr(0644,root,root,0755)
%{_datadir}/%{name}/apps/el-example.war
%{_datadir}/maven2/poms/JPP.%{name}-apps-el-example.pom

%files webapp-examples
%defattr(0644,root,root,0755)
%{_datadir}/%{name}/apps/examples.war
%{_datadir}/maven2/poms/JPP.%{name}-apps-examples.pom

%files webapps-faces
%defattr(0644,root,root,0755)
%{_datadir}/%{name}/apps/faces-example1.war
%{_datadir}/%{name}/apps/faces-example2.war
%{_datadir}/maven2/poms/JPP.%{name}-apps-faces-example1.pom
%{_datadir}/maven2/poms/JPP.%{name}-apps-faces-example2.pom

%files webapp-mailreader
%defattr(0644,root,root,0755)
%{_datadir}/%{name}/apps/mailreader.war
%{_datadir}/maven2/poms/JPP.%{name}-apps-mailreader.pom

%files webapp-scripting-mailreader
%defattr(0644,root,root,0755)
%{_datadir}/%{name}/apps/scripting-mailreader.war
%{_datadir}/maven2/poms/JPP.%{name}-apps-scripting-mailreader.pom
%endif # apps

%if %with zips
%files zip
%defattr(0644,jboss,jboss,0755)
%dir %{_javadir}*/
%exclude %{_javadocdir} 
%dir %{_javadir}*/jbossas-fordev
%{_javadir}*/jbossas-fordev/%{name}-%{version}-all.zip
%{_javadir}*/jbossas-fordev/%{name}-%{version}-lib.zip
%if %with apps
%{_javadir}*/jbossas-fordev/%{name}-%{version}-apps.zip
%endif
%{_javadir}*/jbossas-fordev/%{name}-%{version}-docs.zip

%files src-zip
%defattr(0644,jboss,jboss,0755)
%dir %{_javadir}*/
%exclude %{_javadocdir} 
%dir %{_javadir}*/jbossas-fordev
%{_javadir}*/jbossas-fordev/%{name}-%{version}-src.zip
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*/
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri May 09 2014 David Walluck <dwalluck@redhat.com> 0:1.3.10-6
- own %%{_datadir}/%%{name}/apps directory
- enable profiles during javadoc and site execution

* Thu May 08 2014 David Walluck <dwalluck@redhat.com> 0:1.3.10-5
- restore previous docs layout

* Thu May 08 2014 David Walluck <dwalluck@redhat.com> 0:1.3.10-4
- restore previous struts-apps location

* Mon May 05 2014 David Walluck <dwalluck@redhat.com> 0:1.3.10-3
- add patch for CVE-2014-0114 (Resolves: bz#1091938)
- remove BuildRequires: jboss-javaee-javadoc (missing)
- skip checkstyle (com.google.common.collect.Lists)
- fix javax.servlet.jsp.tagext.JspIdConsumer signer error
- move apps dir to %%{_javadir}/%%{name}-apps

* Mon Feb 28 2011 David Walluck <dwalluck@redhat.com> 0:1.3.10-2
- remove a couple patches
- fix coreonly build
- fix build to not be circular

* Mon Feb 28 2011 David Walluck <dwalluck@redhat.com> 0:1.3.10-1.6
- update javadoc link patch
- update file list for brew
- add repolib

* Thu Dec 10 2009 David Walluck <dwalluck@redhat.com> 0:1.3.10-1.5
- BuildRequires struts for packaging the apps

* Wed Dec 09 2009 David Walluck <dwalluck@redhat.com> 0:1.3.10-1.4
- fix jars in WEB-INF/lib

* Wed Dec 09 2009 David Walluck <dwalluck@redhat.com> 0:1.3.10-1.3.1
- switch to servletapi4 for building

* Wed Dec 09 2009 David Walluck <dwalluck@redhat.com> 0:1.3.10-1.3
- enable JSF RI
- BuildRequires: zip
- link javadocs to system javadocs

* Thu Dec 03 2009 David Walluck <dwalluck@redhat.com> 0:1.3.10-1.2
- enable zips

* Thu Oct 08 2009 David Walluck <dwalluck@redhat.com> 0:1.3.10-1.1
- change avalon (Build)Requires for brew
- remove checkstyle BuildRequires

* Tue Sep 29 2009 David Walluck <dwalluck@redhat.com> 0:1.3.10-1
- 1.3.10
- use groovy15
- add core and extras packages
- update Requires based on poms
- move poms to packages

* Wed Feb 04 2009 Fernando Nasser <fnasser@redhat.com> - 0:1.3.8-3
- Plain rebuild

* Tue Jan 06 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.3.8-2.jpp5
- Install struts-master.pom

* Thu Nov 05 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.3.8-1.jpp5
- 1.3.8

* Tue Feb 27 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2.9-5jpp
- Drop tomcat5 BR when building coreonly
- Fix gcj_support build

* Fri Aug 25 2006 Deepak Bhole <dbhole@redhat.com> - 0:1.2.9-4jpp
- Fix requirements

* Tue Aug 22 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.9-3jpp.1
- Merge with upstream for upgrade to 1.2.9
- Use symlinks instead of actual files in WEB-INF/lib folders
- Add conditional native compilation

* Tue Aug 22 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.9-3jpp
- Remove duplicate macros
- Fix removal of old struts-el documentation link
- Create coreonly option

* Thu Apr 06 2006 Ralph Apel <r.apel@r-apel.de> - 0:1.2.9-2jpp
- Switch to _javadir/cactus-14/*.jar
- Thus require cactus >= 1.7.1-2jpp

* Wed Mar 29 2006 Ralph Apel <r.apel@r-apel.de> - 0:1.2.9-1jpp
- Upgrade to 1.2.9

* Thu Oct 20 2005 Ralph Apel <r.apel@r-apel.de> - 0:1.2.7-2jpp
- Add struts-chain subpackages
- Add struts-el subpackages
- Add struts-faces subpackages

* Tue Jul 26 2005 Fernando Nasser <fnasser@redhat.com> - 0:1.2.7-1jpp
- Upgrade to 1.2.7

* Fri May 27 2005 Gary Benson <gbenson@redhat.com> - 0:1.2.4-2jpp
- Build with servletapi5.
- Add build dependency on ant-nodeps.

* Tue Feb  1 2005 Joe Orton <jorton@redhat.com>
- Change webapps subpackages' tomcat dependencies to prereqs.

* Fri Nov 26 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.2.4-1jpp
- Upgrade to 1.2.4

* Sat Sep 04 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.1-3jpp
- Rebuilt with Ant 1.6.2

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:1.1-2jpp
- Fixed runtime requires
- Fix examples by making symlinks work in their respective (sub-)directories,
  the template comes for tomcat4 from Source #2 and for tomcat5 from Source #3

* Fri Jan  9 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:1.1-1jpp
- Updated to 1.1
- Use tomcat4 real webapps dir instead of -compat provided app dir
- To compile against < JDK 1.4 jdkmajorver needs to be set to 1.3

* Tue Mar 25 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.0.2-4jpp
- for jpackage-utils 1.5

* Thu Mar 28 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.2-3jpp 
- fixed incorrect files in manual package

* Wed Mar 27 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.2-2jpp 
- corrected URL
- cleaned webapps
- tagged webapps

* Sun Mar 24 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.2-1jpp 
- 1.0.2
- generic servlet support
- distinct webapps for tomcat3 and tomcat4
- no duplicate files for webapps
- correct file ownership for webapps

* Wed Jan 23 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-4jpp
- section macro
- versioned dir for javadoc
- no dependencies for manual and javadoc packages
- stricter dependencies for webapp package
- requires tomcat3
- no more requires servlet3 as tomcat3 requires it
- requires and buildrequires xalan-j2 >= 2.2.0
- adaptation to new servlet3 package
- adaptation to new xalan-j2 package
- adapation to new tomcat3 package
- uncompressed webapps

* Wed Dec 5 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-3jpp
- javadoc into javadoc package

* Tue Nov 20 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 1.0-2jpp
- removed packager tag
- new jpp extension
- added xalan 2.2.D13 support

* Thu Nov 1 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-1jpp
- first JPackage release
